package nl.tue.id.pp.boids;

/**
 * 
 * @author ppeters
 * 
 * A Shape represents a shape on the screen
 */
public class Shape {

	/*
	 *  properties
	 */
    private int xpos;
    private int ypos;    // x, y position

    /** Shape constructor
     * 
     * @param x x position on canvas
     * @param y y position on canvas
     */
    public Shape(int x, int y) {
        setPos(x,y);
    }
    
    /** Set position of shape
     * 
     * @param x x position on canvas
     * @param y y position on canvas
     */
    public void setPos(int x, int y) {
        setX(x);
        setY(y);
    }

    /** Set x position of shape
     * 
     * @param x x position on canvas
     */
    public void setX(int x) {
        xpos = x;
    }

    /** Set y position of shape
     * 
     * @param y y position on canvas
     */
    public void setY(int y) {
        ypos = y;
    }

    /** get x position of shape
     * 
     * @return x position
     */
    public int getX() {
        return xpos;
    }

    /** get y position of shape
     * 
     * @return y position
     */
    public int getY() {
        return ypos;
    }
   
    /** draw shape in canvas
     * (abstract)
     */
    public void render() {
    }
    
}
