package nl.tue.id.pp.boids;
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import processing.core.*;

/**
 * 
 * @author ppeters
 * 
 * Example program using processing library to display a single shape
 * that rotates itself and also is rotated depending on the mouse pointer
 */
public class SingleBoidExample extends PApplet {

	/*
	 * final properties
	 */
	private static final long serialVersionUID = 1L; 	// version
	private final boolean squareboid = false;			// display square or triangle

	/*
	 * private properties
	 */
	private boolean rotating = false;					// rotation active or not
	private Boid myBoid;								// the boid

	/** setup drawing canvas
	 * (non-Javadoc)
	 * @see processing.core.PApplet#setup()
	 */
	public void setup() {
		// create field that accomodates all boids
		size(420, 420);
		// refreshes per second...
		frameRate(30);
		// anti aliasing
		smooth();

		// create the boid
		if (squareboid) {
			myBoid = new SquareBoid(this, 200, 200, 0);
		} else {
			myBoid = new TriangleBoid(this, 200, 200, 0);
		}
	}

    /** When the mouse is moved, focus all boids
     * (non-Javadoc)
     * @see processing.core.PApplet#mouseMoved()
     */
	public void mouseMoved() {
		myBoid.pointAt(mouseX, mouseY);
	}

    /** When the mouse is pressed all boids start rotating
     * (non-Javadoc)
     * @see processing.core.PApplet#mousePressed()
     */
	public void mousePressed() {
		rotating = !rotating;
	}

	/* 
	 * rotate the boid
	 */
	private void rotateBoid() {
		myBoid.setAngle(myBoid.getAngle() + random(0.2f));
	}

	/*
	 * draw the boid
	 */
	private void drawBoid() {
		myBoid.render();
	}

    /** render all boids on screen
     * (non-Javadoc)
     * @see processing.core.PApplet#draw()
     */
	public void draw() {
		// set backgroundcolor
		background(102);
		// perform changes here before drawing...
		if (rotating) {
			rotateBoid();
		}
		// draw all boids
		drawBoid();
	}

	/** main entry point
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		PApplet.main(new String[] { "nl.tue.id.pp.boids.SingleBoidExample" });
	}

}
